﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using HeuristicLab.Core;

namespace HeuristicLab.EvolutionaryTracking {
  public interface IGenericGraph<T> : IItem where T : class, IVertex {
    bool Contains(T t); // graph contains specific node?
    bool Any(Func<T, bool> predicate); // graph contains any nodes matching the given predicate?
    void Clear(); // clear graph
    void AddNode(T nodeData);
    void RemoveNode(T t); // remove node if contained in the graph
    List<T> Nodes { get; }
  }
}
